<script lang="ts">
  import { browser } from '$app/environment';
  import { isBoolean } from '@common/helpers/DataTypeHelper.js';
  import type { SelectorOption } from './Selector.js';

  export let options: SelectorOption[] = [];
  export let selected: SelectorOption;

  let selector: HTMLDivElement;
  let optionsElm: HTMLDivElement;
  let active: boolean;

  $: active ? monitorClick(active) : monitorClick(active);

  const monitorClick = (bool: boolean) => {
    if (!browser) return;

    const onClickOutside = (e) => {
      const classList = Array.from(e.target?.classList);

      if (
        (!classList.includes('selected') &&
          !classList.includes('options') &&
          !classList.includes('option')) ||
        (classList.includes('selected') && e.target.parentNode !== selector)
      ) {
        active = false;
      }
    };

    if (bool) {
      // To prevent multiple event listener
      document.removeEventListener('click', onClickOutside);
      document.addEventListener('click', onClickOutside);
    } else {
      document.removeEventListener('click', onClickOutside);
    }
  };

  const onClickSelect = () => {
    active = !active;
  };

  const onSelect = (id: number) => {
    active = false;
    selected = options[id];
  };
</script>

<div
  bind:this={selector}
  class="selector-wrapper">
  <button
    class="selected"
    on:click={onClickSelect}
    ><img
      src={selected.icon}
      width="20" />{selected.opt}</button>
  <div
    bind:this={optionsElm}
    class="options"
    class:open={active}
    class:close={isBoolean(active) && !active}>
    {#each options as option (option.id)}
      <button
        class="option"
        on:click={onSelect.bind(null, option.id)}>
        <img
          src={option.icon}
          width="20" />{option.opt}</button>
    {/each}
  </div>
</div>

<style lang="postcss">
  .selector-wrapper {
    width: 100px;
    height: 28px;

    img {
      margin-right: 10px;
    }
  }

  .selected {
    display: flex;
    width: 100%;
    padding: 3px 5px;
    border: 1px solid grey;
    border-radius: var(--radius-2);
  }

  .options {
    position: relative;

    /* Initial closed state */
    top: 0;
    display: flex;
    width: 100px;
    height: fit-content;
    flex-direction: column;
    padding: 5px 10px;
    border-radius: var(--radius-2);
    background-color: white;
    box-shadow: var(--box-shadow);
    gap: 5px;
    opacity: 0;
    pointer-events: none; /* Disable interactions when hidden */
    transition:
      opacity 0.2s,
      top 0.2s;

    &.open {
      top: 5px;
      opacity: 1;
      pointer-events: auto; /* Enable interactions when open */
    }

    &.close {
      top: 0;
      opacity: 0;
    }
  }

  .option {
    display: inline-flex;
    align-items: center;
  }
</style>
